EDIT - bug #6424

Empty name creates problem/NPE in name editor
02/16/2017 09:01 PM - Andreas Mdller

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Katja Luther % Done: 50%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 4.6

Severity: critical Found in Version: Release 4.6
Description

When pressing return on the end of the synonymy list a new empty record appears. When trying to save it is labeled "Click to add
name" and a warning is given that an attempt was made to save a taxon/synonym with an empty name.

When trying to delete this name an NPE is thrown:

login : admin
editor version : 4.6.0.201702161652
server : test.e-taxonomy.eu (edit-test) / rem_conf_am
schema version : 4.1.0.0.201607300000
os : Windows Server 2012 R2 6.3 amd64
java : 1.8.0_121
org.eclipse.core.commands.ExecutionException: While executing the operation, an exception occurred

at org.eclipse.core.commands.operations.DefaultOperationHistory.execute (DefaultOperationHistor
y.Jjava:521)

at eu.etaxonomy.taxeditor.model.AbstractUtility$l.run (AbstractUtility.java:345)

at org.eclipse.jface.operation.ModalContext.runInCurrentThread (ModalContext.java:464)

at org.eclipse.jface.operation.ModalContext.run (ModalContext. java:372)

at org.eclipse.jface.window.ApplicationWindow$1l.run (ApplicationWindow. java:759)

at org.eclipse.swt.custom.BusyIndicator.showWhile (BusyIndicator.java:70)

at org.eclipse.jface.window.ApplicationWindow.run (ApplicationWindow. java:756)

at org.eclipse.ui.internal.WorkbenchWindow.run (WorkbenchWindow. java:2649)

at org.eclipse.ui.internal.progress.ProgressManager$RunnableWithStatus.run (ProgressManager. jav
a:13406)

at org.eclipse.swt.custom.BusyIndicator.showWhile (BusyIndicator. java:70)

at org.eclipse.ui.internal.progress.ProgressManager$7.run (ProgressManager. java:1184)

at org.eclipse.swt.widgets.Synchronizer.syncExec (Synchronizer. java:180)

at org.eclipse.ui.internal.UISynchronizer.syncExec (UISynchronizer.java:150)

at org.eclipse.swt.widgets.Display.syncExec (Display.java:4683)

at org.eclipse.ui.internal.progress.ProgressManager.runInUI (ProgressManager. java:1182)

at eu.etaxonomy.taxeditor.model.AbstractUtility.runInUI (AbstractUtility.java:657)

at eu.etaxonomy.taxeditor.model.AbstractUtility.executeOperation (AbstractUtility.java:363)

at eu.etaxonomy.taxeditor.editor.name.handler.DeleteTaxonBaseHandler.doExecute (DeleteTaxonBase
Handler. java:91)

at eu.etaxonomy.taxeditor.editor.name.handler.DeleteTaxonBaseHandler.execute (DeleteTaxonBaseHa
ndler. java:56)

at org.eclipse.ui.internal.handlers.HandlerProxy.execute (HandlerProxy. java:293)

at org.eclipse.core.commands.Command.executeWithChecks (Command. java:476)

at org.eclipse.core.commands.ParameterizedCommand.executeWithChecks (ParameterizedCommand. java:
508)

at org.eclipse.ui.internal.handlers.HandlerService.executeCommand (HandlerService.java:169)

at org.eclipse.ui.internal.handlers.SlaveHandlerService.executeCommand (SlaveHandlerService. jav
a:241)

at org.eclipse.ui.internal.handlers.SlaveHandlerService.executeCommand (SlaveHandlerService. jav
a:241)

at org.eclipse.ui.internal.handlers.SlaveHandlerService.executeCommand (SlaveHandlerService. jav
a:241)

at org.eclipse.ui.menus.CommandContributionItem.handleWidgetSelection (CommandContributionItem.
Jjava:829)

at org.eclipse.uil.menus.CommandContributionItem.access$19 (CommandContributionItem. java:815)

at org.eclipse.ui.menus.CommandContributionItem$5.handleEvent (CommandContributionItem. java:805
at org.eclipse.swt.widgets.EventTable.sendEvent (EventTable. java:84)

at org.eclipse.swt.widgets.Widget.sendEvent (Widget.java:1053)

at org.eclipse.swt.widgets.Display.runDeferredEvents (Display.java:4165)

at org.eclipse.swt.widgets.Display.readAndDispatch (Display.java:3754)

at org.eclipse.ui.internal.Workbench.runEventLoop (Workbench. java:2701)

at org.eclipse.ui.internal.Workbench.runUI (Workbench.java:2665)

at org.eclipse.ui.internal.Workbench.access$4 (Workbench. java:2499)

at org.eclipse.ui.internal.Workbench$7.run (Workbench. java:679)

at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:332)

at org.eclipse.ui.internal.Workbench.createAndRunWorkbench (Workbench. java:668)

at org.eclipse.ui.PlatformUI.createAndRunWorkbench (PlatformUI. java:149)

at eu.etaxonomy.taxeditor.Application.start (Application. java:24)

at org.eclipse.equinox.internal.app.EclipseAppHandle.run (EclipseAppHandle.java:196)

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.runApplication (EclipseAppLaunc
her.java:110)

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.start (EclipseAppLauncher. java:
79)

at org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:344)

at org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:179)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.eclipse.equinox.launcher.Main.invokeFramework (Main. java:622)

at org.eclipse.equinox.launcher.Main.basicRun (Main. java:577)

at org.eclipse.equinox.launcher.Main.run(Main.java:1410)
Caused by: java.lang.NullPointerException

at eu.etaxonomy.taxeditor.editor.name.operation.DeleteSynonymOperation.execute (DeleteSynonymOp
eration. java:75)

at org.eclipse.core.commands.operations.DefaultOperationHistory.execute (DefaultOperationHistor
y.Jjava:513)

52 more

This happens for both "delete” and "delete all names".

It is difficult to get rid of this empty name (only by filling it and then delete it, but also then, if the name was not yet saved an NPE is
thrown when trying to delete)

Associated revisions

Revision b8da2ad7 - 03/09/2017 03:03 PM - Katja Luther

fix #6424: check if name is already persisted before trying to delete

Revision 898894c8 - 03/10/2017 09:24 AM - Katja Luther
fix #6424: fix NPE when choosing delete all empty names

History

#1 - 02/16/2017 09:02 PM - Andreas Miuller

- Target version changed from Unassigned CDM tickets to Release 4.6

#2 - 02/16/2017 09:04 PM - Andreas Miuller

- Description updated

#3 - 03/09/2017 03:03 PM - Katja Luther
- Status changed from New to Resolved

- % Done changed from 0 to 50

Applied in changeset taxeditor|b8da2ad780bc334e229c35bdaefb3e687fc99889.

#4 - 03/09/2017 03:05 PM - Katja Luther

- Assignee changed from Katja Luther to Andreas Miiller

please review
https://dev.e-taxonomy.eu/redmine/projects/edit/repository/taxeditor/revisions/b8da2ad780bc334e229c35bdaefb3e687fc99889

#5 - 03/10/2017 01:02 AM - Andreas Miiller
- Description updated
- Status changed from Resolved to Closed

- Assignee changed from Andreas Miiller to Katja Luther

Seems to work correctly now.

#6 - 03/10/2017 01:08 AM - Andreas Miiller
- Status changed from Closed to Feedback

Sorry, | have to reopen.

When | tried to delete the name with "Delete all empty names" | still got an NPE, while delete for a single name works.

login : admin
editor version : 4.6.0.201703092001
server : (edit-test)

schema version
os : Windows Server 2012 R2 6.3 amd64
java : 1.8.0_121
java.lang.NullPointerException
at eu.etaxonomy.taxeditor.editor.name.handler.DeleteTaxonBaseHandler.doExecute (DeleteTaxonBaseHandler. java
:81)
at eu.etaxonomy.taxeditor.editor.name.handler.DeleteAllEmptyNamesHandler.execute (DeleteAllEmptyNamesHandle
r.java:37)
at org.eclipse.ui.internal.handlers.HandlerProxy.execute (HandlerProxy.java:293)
at org.eclipse.core.commands.Command.executeWithChecks (Command. java:476)
at org.eclipse.core.commands.ParameterizedCommand.executeWithChecks (ParameterizedCommand. java:508)
at org.eclipse.ui.internal.handlers.HandlerService.executeCommand (HandlerService. java:169)
at org.eclipse.ui.internal.handlers.SlaveHandlerService.executeCommand (SlaveHandlerService. java:241
at org.eclipse.ui.internal.handlers.SlaveHandlerService.executeCommand (SlaveHandlerService. java:241
at org.eclipse.ui.internal.handlers.SlaveHandlerService.executeCommand (SlaveHandlerService.java:241)
at org.eclipse.ui.menus.CommandContributionItem.handleWidgetSelection (CommandContributionItem. java:829)
at org.eclipse.uil.menus.CommandContributionItem.access$19 (CommandContributionItem. java:815)
at org.eclipse.uil.menus.CommandContributionItem$5.handleEvent (CommandContributionItem. java:805)
at org.eclipse.swt.widgets.EventTable.sendEvent (EventTable. java:84)
at org.eclipse.swt.widgets.Widget.sendEvent (Widget.java:1053)

)
)

at org.eclipse.swt.widgets.Display.runDeferredEvents (Display.java:4165)

at org.eclipse.swt.widgets.Display.readAndDispatch (Display.java:3754)

at org.eclipse.ui.internal.Workbench.runEventLoop (Workbench.java:2701)

at org.eclipse.ui.internal.Workbench.runUI (Workbench.java:2665)

at org.eclipse.ui.internal.Workbench.access$4 (Workbench. java:2499)

at org.eclipse.ui.internal.Workbench$7.run (Workbench.java:679)

at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:332)

at org.eclipse.ui.internal.Workbench.createAndRunWorkbench (Workbench. java:668)

at org.eclipse.ui.PlatformUI.createAndRunWorkbench (PlatformUI. java:149)

at eu.etaxonomy.taxeditor.Application.start (Application.java:24)

at org.eclipse.equinox.internal.app.EclipseAppHandle.run (EclipseAppHandle. java:196)
at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.runApplication (EclipseAppLauncher.java:110

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.start (EclipseAppLlauncher. java:79)
at org.eclipse.core.runtime.adaptor.EclipseStarter.run (EclipseStarter. java:344)

at org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:179)

at sun.reflect.NativeMethodAccessorImpl.invoke0 (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.eclipse.equinox.launcher.Main.invokeFramework (Main. java:622)

at org.eclipse.equinox.launcher.Main.basicRun (Main. java:577)

at org.eclipse.equinox.launcher.Main.run (Main.java:1410)

#7 - 03/10/2017 09:24 AM - Katja Luther

- Status changed from Feedback to Resolved

Applied in changeset taxeditor|898894c82879b1b37fe04b055cdc70bce67bb183.

#8 - 03/10/2017 09:27 AM - Katja Luther

- Status changed from Resolved to Feedback
https://dev.e-taxonomy.eu/redmine/projects/edit/repository/taxeditor/revisions/898894c82879b1b37fe04b055cdc70bce67bb183

sorry, now it works also with delete all empty names.

#9 - 03/10/2017 09:27 AM - Katja Luther
- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Andreas Miiller

#10 - 03/10/2017 10:24 AM - Andreas Miiller

Could you still adapt the message that is shown if one tries to save a taxon with empty names "Es wurde versucht ein Taxon oder Synonym mit
einem leeren Namen zu speichern. Vorgang abgebrochen” in a way that it is mentioned that there is a "Delete all empty names" functionality.

E.g. "... Use the 'Delete all empty names' functionality from right click menu to remove empty names."

#11 - 03/10/2017 10:24 AM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Miiller to Katja Luther
Generally it works now and ticket can be closed.

#12 - 03/29/2017 10:52 AM - Katja Luther
- Status changed from Feedback to Closed

#13 - 03/29/2017 12:08 PM - Andreas Miiller

Can you please leave a message if you have changed the message mentioned in comment #10 somehow?
